Please keep this updated!

-: removed
+: added
~: changed
*: info
!: fixed

Changelog eMuleFuture v0.01:

* First version, base TS v1.52+ (in progress) [WiZaRd]
~ Modstring changed [WiZaRd]
- "Tombstone" references removed, except the splashscreen and icon [WiZaRd]
+ Preprocessor optimization - TAG: WiZaRd::EasyPreprocessor
+ Separate Prefpage added - TAG: WiZaRd::eMuleFuture-Prefspage
~ Moved all separate features of TS into the new prefpage [WiZaRd]
~ Adjusted "Beta" Compileroption (use this if you want to test the version, it's a lot faster than release)
~ Code now compatible with Visual Studio 2005. Use emule_vc80.vcproj. [shadow2004]
  TAG: shadow2004::VS2005compatible 
+ Added dynamic splash-screen  - TAG: the black hand::SplashScreenEx [shadow2004]
+ PNCheck added for eMuleFutute - TAG: WiZaRd::PNCheck
+ XPGroupBox implemented (just a test now) [shadow2004]
  TAG: TPT::XPGroupBox 
+ Advanced AHL added [WiZaRd] - TAG: WiZaRd::AutoHL
+ searchCatch by SF [WiZaRd] - TAG: WiZaRd::searchCatch [SLUGFILLER]
+ if sessionratio applies, the current limit is shown in title (only if "show rates on title" is enabled) [WiZaRd] - TAG: WiZaRd::SessionRatio
+ ECR by Spike2 - TAG: WiZaRd::ECR [Spike2]
+ Sliderbars from eMule+ [WiZaRd] - TAG: WiZaRd::SlideBar [eMule+]	
! memleak fixes in SplashScreenEX [WiZaRd] - TAG: WiZaRd::Memleak FiX
~ proper log colors [WiZaRd] - TAG: WiZaRd::"Proper" Colors
! hover fix in notifier [WiZaRd] - TAG: WiZaRd::Wrong Hover FiX
+ more EMF functions [WiZaRd] - TAG: WiZaRd::PNCheck
~ prefslider in eMF style [WiZaRd]
+ 3D-Text effect for prefsliders [WiZaRd] - TAG: WiZaRd::3D-Text
+ Anti-USS-verbose spam [WiZaRd] - TAG: WiZaRd::Prevent USS Spam 
+ more EMF functions/changes [WiZaRd] - TAG: WiZaRd::PNCheck/EMF
! Webserver FiX as detected here: http://forum.emule-project.net/index.php?showtopic=111557 [WiZaRd] - TAG: WiZaRd::WebServerBanFiX
+ Preferences Side Banner - TAG: Spike2::Prefs Side Banner [TPT]
+ Emulate other - TAG: Spike2::Emulate other
+ You can now rename friends as you like [WiZaRd] - TAG: WiZaRd::PNCheck/EMF
+ ModIconMapper - allows easy mapping of available mod icons [WiZaRd] - TAG: WiZaRd::ModIconMappings
+ Added extended ModStatistic - TAG: shadow2004::ModStats [TPT]
! small fixes added to ModStatistic [WiZaRd]
~ merged to eMule v0.47b Beta 1 [shadow2004]
! fixed memleak in beta1 [WiZaRd]
+ added notifier on friendslist update [WiZaRd]
! fixed modthief problem (finally!) [WiZaRd]
+ added UPnP-Support - TAG: shadow2004::UPnPNAT Support [MoNKi]
~ lesser rework of UPnP code to remove warnings and bugs [WiZaRd]
+ added UPnP+hint to first start wizard [WiZaRd]
+ added link to emulefuture to tools menue [WiZaRd]
+ added filtering for servermessages [WiZaRd] - TAG: WiZaRd::ServerMessageFilter
+ added show remote QueueRankDifference [shadow2004] - TAG: shadow2004::ShowQDifference [itsonlyme]
+ added show estaminated time till downloading from client [shadow2004] - TAG: shadow2004::QRETA [SLUGFILLER]
~ obfuscutiondetailrow in sourcedetails should now have the correct length [shadow2004]
! added XS fix for cryptoclients - TAG: WiZaRd::XS-FiX [Xanatos]
~ changed search file colors [WiZaRd] - TAG: WiZaRd::SearchColors
 * Downloading = orange
 * DownloadStopped = red
 * Shareing = green
 * Known = dark green
 * Cancelled = dark yellow
- removed skinning-relevant code [shadow2004]
~ small rework in ModIconMapper, to show the Modicon in the ..-Lists on the right position [shadow2004] * REALFIX * [WiZaRd]
+ added graphic toolbar (Fixes by JvA included) [WiZaRd/shadow2004] - TAG: shadow2004::Toolbar [J.C.Connor/WiZaRd/JvA]
! added ChatTab context FiX - TAG: WiZaRd::Context FiX
~ added eMF-Toolbar-Skin by MondGott [shadow2004]
~ added prefs for friendlistupdate after ip-change [shadow2004]
~ added 3D text to toolbar buttons [WiZaRd]
+ if you click onto the star-circled mule then the homepage will be opened [WiZaRd]
~ added prefs for UPnP-service-control (Windows) [shadow2004]
! help-button-fix. opens now the help :-) [WiZaRd]
~ added some missing langstrings [shadow2004]
+ added eMF server.met to serverlist dropdown - TAG: WiZaRd::EMF-Server.met [WiZaRd]
+ added EMF credits to credits thread - TAG: WiZaRd::ModCredits [WiZaRd]
+ added new mod version management - TAG: WiZaRd::ModVersionSystem [WiZaRd]
+ added prefs to switch between the toolbar label styles [shadow2004]
+ some data of friends is stored now so you can always see e.g. UL/DL stats even if the client is offline - TAG: WiZaRd::Data without client [WiZaRd]
+ added prefs to show downloads in bold - TAG: WiZaRd/shadow2004::DL in Bold
~ updated italian and spanish lang-files
! added MM crashfix by Xman - TAG: WiZaRd::MM CrashFiX [Xman]

Changelog eMuleFuture v0.02:
~ fast reask for MLDonkeys is always enabled [WiZaRd]
~ changed QRETA code to work around buffer overflows [WiZaRd]
! fixed wrong string in friend rename [WiZaRd]
~ filebuffer size adjustable to 30MB [WiZaRd] - TAG: WiZaRd::IntelliFlush
+ added adjustable filebuffer time (free time in minutes) [WiZaRd] - TAG: WiZaRd::IntelliFlush
+ added intelliflush [WiZaRd]
! added XS-workaround for older clients [WiZaRd] - TAG: WiZaRd::XS-Workaround
+ added ed2kFilterTypes to SharedFilesDirTree by Avi3k/WiZaRd [WiZaRd] - TAG: WiZaRd::SharedView Ed2kType [Avi3k]+WiZaRd::SharedView Ed2kType [WiZaRd]
+ added a separate preferences file (emfprefs.ini) to save mod values [WiZaRd] - TAG: WiZaRd::Own Prefs
~ disable connection option for server which do not support obfuscation if obfuscation is required [WiZaRd] - TAG: WiZaRd::Obfuscation FiX
 * pointed out by Howe here: http://forum.emule-project.net/index.php?showtopic=114887
! show the correct serverport in networkinfodlg if obfuscution is used [shadow2004] - TAG: shadow2004::show correct serverport [WiZaRd]
! fixed a problem, that prevents an obfuscated serverconnection [shadow2004]
! fixed wrong banning of clients due to "bad data amount" if near to completion (at least I hope so) [WiZaRd]
+ ip2country adapted from Eastshare/iONiX [shadow2004] - TAG: shadow2004::IP2Country [EastShare]
  -> has to be continued. its not completed
+ ip2country flag per file [WiZaRd] - TAG: WiZaRd::IP2Country Addon: File Origin
  -> offer an option to disable this? (No. Shown, if flags shown)
  * if "default" flag has most clients then NO flag will be shown
  * if 2 or more flags have the same amount of clients then the DEFAULT flag will be shown
  * otherwise the flag with most clients will be shown!
~ added forgotten code to the Analyzer (punishments for XS-Spammers) [Spike2]
+ small patch in ListenSocket.cpp from emule+ [Spike2]
+ added Update-Prefpage [shadow2004] - TAG: shadow2004::Updates-Prefspage
+ added new addons-directory for additional dlls and files [shadow2004/WiZaRd] - TAG: shadow2004::AddonDirectory or WiZaRd::AddonDirectory
~ changed ModIconDLL.dll homepath to addons-directory [shadow2004]
~ changed countryflagX.dll homepath to addons-directory [shadow2004]
+ added group on update-prefpage for ModIconDLL-Update [shadow2004]
+ added ModIconDll-Update [shadow2004] - TAG: shadow2004::ModIconDLL Update
! fixed unfair client treatment, pointed out by eklmn - TAG: WiZaRd::FiX unfair client treatment [http://forum.emule-project.net/index.php?showtopic=116699]

Changelog eMuleFuture v0.03:
+ added ClipStat support - TAG: WiZaRd::ClipStat
+ added Feedback support - TAG: WiZaRd::Feedback
+ added zip/gzip/rar support to the modicon dll update - TAG: WiZaRd::ModIconDLL Update
+ added ConChecker - TAG: Spike2::ConChecker [eWombat]
+ added Reset Kad-IP on IP-Change [based on code from Pawcio!] - TAG: Spike2::Reset Kad-IP on IP-Change [based on code from Pawcio!]
+ added "Do not alter DVD-Video files" - TAG: Spike2::Do NOT alter DVD-Video files [BlueSonicBoy]
+ added Reconnect to Kademlia (after Connection error) - TAG: Spike2::Reconnect to Kademlia [Pawcio]
+ added PBF system (4 options) - TAG: WiZaRd::Payback first
+ added ICS - TAG: WiZaRd::ICS [enkeyDEV]
~ changed some codeparts for better performance - TAG: WiZaRd::Optimization
- removed some useless codeparts - TAG: WiZaRd::Useless code
~ official minimule is static now - TAG: WiZaRd::Static MM
 * the MM also uses some cooler effects now - for Spike2 :)
! added ip2country-fix for V$ 2005 (http://forum.emule-project.net/index.php?showtopic=118532) - TAG: WiZaRd::VS2005compatible
~ changed ip2country.csv path to addons directory [WiZaRd] - TAG: WiZaRd::AddonDirectory
~ changed ipfilter.dat path to addons directoy [WiZaRd] - TAG: WiZaRd::AddonDirectory
~ reworked the clientanalyzer a bit [WiZaRd]
~ changed the modicondll update to zip-file on eMuleFuture [WiZaRd]
~ redesigned the shared files wnd a bit [WiZaRd] - TAG: WiZaRd::SharedWnd Redesign
~ added XP group box style to box in shared files wnd and fixed some parts for the box in chatwnd [WiZaRd] - TAG: TPT::XPGroupBox [WiZaRd]
~ changed some code to work around bad clients systems [WiZaRd] - TAG: WiZaRd::BadClientFlag
+ added Anti-HideOS to backup ICS [WiZaRd] - TAG: WiZaRd::AntiHideOS [netfinity]
 * Note: we only display this data and don't use it to request blocks because some bad mods (e.g. Morph) would block us then
		 unfortunately we have to waste memory that way for another partstatus... personally I'd preferred to mix the partstatus with the seen status 
+ added and changed a lot around KAD, including anti-fragment by netfinity, (good) parts of safekad and more (not completely tagged, sorry) - TAG: WiZaRd::KadAddons
+ added Winsock2-support - TAG: Spike2::Winsock2 [eWombat]
+ Obfuscate HTTP-Transfers, if Obfuscation is required - TAG: Spike2::Obfuscate HTTP-Transfers [Morph]
+ Aux-Ports-support - TAG: Spike2::Aux Ports support [lugdunummaster]
! Small fix in SearchResultsWindow - TAG: Spike2::Small fix [WiZaRd]
+ Display Userhash in Status-Window - TAG: Spike2::Display Userhash in StatusWindow [iONiX]
! Small fix in SharedFileList.cpp - Spike2::Publish small incomplete files fix [WiZaRd]
+ WebBrowser from Pruna (modified by WiZaRd) - TAG: WiZaRd::WebBrowser [Pruna]
+ added XP-menus from TPT (modified by shadow2004 and WiZaRd) - TAG: shadow2004::XPMenu [TPT] AND WiZaRd::XPMenu
+ sysinfo code added and updated  - WiZaRd::SysInfo
+ CPU and RAM info added to transferwindow - TAG: WiZaRd::ResourceBars
+ Safe Tag Sending (Hello/Info packets) avoids "invalid tag count" punishments - TAG: WiZaRd::Safe Tag Sending
~ clicking the link to the forums now opens in the built-in browser, same goes for pressing the "help" key on EMF pref pages
+ added clipstat code [WiZaRd]
+ finalized clipStat ! [Spike2]

Changelog eMuleFuture v0.04:
~ updated emulations to current versions (shareaza v2.2.5.0, mldonkey 2.7.6) - TAG: shadow2004::Emulate others [Spike2]
+ added new pref-page for ipfilter-update - TAG: shadow2004::IPFilter-Prefspage
+ added ipfilter-update from txt-file from Morph - TAG: shadow2004::IPFilter-Update [Morph]
+ added ipfilter-update from ed2k-link - TAG: shadow2004::eD2K Updates [WiZaRd]
+ added save/load sources including several enhancements - TAG: JvA::SLS [enkeyDEV]
~ extractwrapper, to prevent deletion of archives after extraction from the incoming-folder [shadow2004]
~ changed extraction-code for ipfilter in PPgSecurity.cpp - TAG: shadow2004::IPFilter-Update
+ autocompletion for ipfilter-url in PPgIPFilter.cpp - TAG: shadow2004::IPFilter-Autocomplete
+ added filename disparity check - TAG: Tux::FDC [BlueSonicBoy]
+ checkbox, that IPFilter-Update (ed2k) can ignore the setting "Add Downloads in paused mode" [shadow2004]
+ added header view+ - TAG: Tux::HeaderView+ [BlueSonicBoy]
+ user can now choose, on which priotity he will share his ipfilters (before downloading) [shadow2004]
! small bug with anchor in shared files window [WiZaRd]
+ added tabbed prefs from TPT slightly modified by shadow2004 - TAG: //>>> shadow2004::Tabbed Prefs [TPT] reworked
+ added redesigned client detail dialog with modicondll addition - TAG: JvA::Redesigned Client Detail Dialog [BlueSonicBoy]
+ added unknown protocol tag string to client detail dialog - TAG: JvA::Unknown Protocol Tags [BlueSonicBoy]
+ added SLS-Settings to ClipStat - TAG: shadow2004::SLS-Settings in ClipStat

Changelog eMuleFuture v0.05:
+ merged to 0.48a final [shadow2004]
~ changed addon-directory to new emule-style - TAG: shadow2004::AddonDirectory
! fixed a bug in prefs while loading ipfilter-update-url [shadow2004]
- removed all old UPnP-Support from MoNKi and WiZaRd's service-starter [shadow2004]
! fixed ip2country for vista ? - TAG: shadow2004::IP2Country Vista-Fix?
+ added ClientAnalyzer-Log - TAG: shadow2004::Log-ClientAnalyzer
+ added MinQR from CiccioBastardo - TAG: shadow2004::minQR [CB]
! fixed the "number of downloads" value bug in clipstat [JvA]
+ added further check in SLS for sources which require obfuscation and skip saving [JvA]
+ added Infinite Queue from SLUGFILLER - TAG: shadow2004::InfiniteQueue [SLUGFILLER]
~ completely reworked FDC - new TAG: shadow2004::FDC [BlueSonicBoy]
! GUI-bug in transfer-window, Reload-Button is now visible again [shadow2004]
! GUI-bug in FiledetailsName-Dialog [shadow2004]

Changelog eMuleFuture v0.06:
~ partially rewritten SLS [WiZaRd]
+ added more AICH security checks [WiZaRd] - TAG: WiZaRd::Additional Security Check
~ request AICH hashes only in case we don't have a valid hash, yet [WiZaRd] - TAG: WiZaRd::Request only if necessary ;)
~ if FS are toggled then the remaining data is recalculated [WiZaRd]
~ added checks to prevent possible memory corruption while reading data from ini files [WiZaRd]
~ changed minQR system to my minRQR system for way less CPU usage [WiZaRd]
+ do not send empty dirs on shared file requests [WiZaRd] - TAG: WiZaRd::Don't send empty dirs
~ updated header view+ implementation [JvA]
! added missing code for "Avoid Credits Accumulate faker" in URLclient [Spike2]

Changelog eMuleFuture v0.07:
! Fixed crash in IPFilterUpdate dialog [WiZaRd]
! fixed wrong checkmark on powershare menue [WiZaRd]
! fixed loading of InfiniteQueue setting [WiZaRd]
! readded some KadAddons by WiZaRd which got lost due to merging [Spike2]
! KAD-directory-fix for Vista - TAG: Spike2::KadFix [godlaugh2007]
! Fix Collection double extension [CiccioBastardo] - TAG: Spike2::CollectionFix [CB]
! CheckDiskspace-fix by Slugfiller - TAG: Spike2::CheckDiskspaceFix [Slugfiller]
! Peercache-Bugfix in StatisticsDlg by Xman [Spike2]
! Fix in PPgDisplay by Xman [Spike2]
! Fixed official memory corruption in webserver.cpp [WiZaRd]
! Fixed memleak in conchecker [WiZaRd]
! Fixed GDI-leak in DirectoryTreeControl pointed out by Rapid_Mule [WiZaRd]
! Fixed checkbox graying for IntelliFlush [WiZaRd]
! fixed that ed2k update added the same time multiple times if the client was restarted
+ CompatClientStats [Stulle] - TAG: Spike2::CompatClientStats [Stulle]
+ Automatic shared files updates [MoNKi/Stulle] - TAG: Spike2:: Automatic shared files updater [MoNKi/Stulle]
+ P2PThreat - detect worms that are harmful to P2P-apps - TAG: Spike2::P2P-Threat [netfinity]
+ HashProgress - TAG: Spike2::HashProgress [o2]
+ Infinite-Queue-AddOn - show infinite-sign when enabled in TransferWnd - TAG: Spike2::InfiniteQueue-Addon [Morph]
+ NoNeededRequeue - TAG: WiZaRd::NoNeededReqeue [SlugFiller]
+ added check to prevent "bad" username usage [WiZaRd] - TAG: WiZaRd::DLP Balancing
 * requires the antileech.dll to be present in the application directory
+ added optimization for shared files updates [WiZaRd] - TAG: WiZaRd::Optimization
 * should fix the "out of resources" issue in sharedfiles, too
+ added a possible workaround for the webbrowser if no IE is present [WiZaRd] - TAG: try to work around IE issues
~ moved the infinite queue checkbox to the tweaks page and combined it with the slider [WiZaRd]
+ LowID2HighIDAutomaticCallback (L2HAC) - TAG: Spike2::L2HAC [enkeyDEV]
+ added workaround for a strange crash in taskbarnotifier.cpp [WiZaRd]
+ added Mephisto to the BadClientFlag and changed the corresponding checks a bit [WiZaRd]
+ added option to delete all friends at once to contextmenu in friendlistctrl [WiZaRd]
+ added messagebox if you try to re-download a file that you already downloaded before, you can then select wether you really want to re-download it [WiZaRd] - TAG: WiZaRd::Indicate already downloaded files
+ added support to built the EMF mod without the mod functions... simply use the corresponding items from the configuration manager [WiZaRd]
~ changed and optimized a LOT of codes [WiZaRd]
~ Updated e+-version-display in ECR [Spike2]
~ changed slotopening treshold a bit to give new slots more time before opening more slots [WiZaRd]
~ displayed queuesize in transferwnd was changed to reflect the queuesize fix [WiZaRd]
~ rewritten ipfilter ed2k update :) [WiZaRd]
 * it will now automatically delete older files from download, reset properly on error and some more optimizations
~ lowered uploadtimer frequency to 10ms (was: 100ms) to improve upload/download performance - TAG: WiZaRd::Faster UploadTimer
~ UPnP settings are hidden on OS which do not support UPnP [WiZaRd]
- removed an optimization in sharedfileswnd.cpp to (hopefully) fix a rare bug
~ clientanalyzer updated to v1.5 (improved modthief support, bad client status block) [WiZaRd]

Changelog eMuleFuture v0.08:
+ merged to 0.49a final [dlarge]
- removed KadAddOns [dlarge]    
~ changed pnglib 1.2.27
~ changed cximage 6.0

//TODO: 
v0.08:
* sollen wir den usern erlauben das ipfilter ed2k update zu umgehen?
* "remove fullchunk" taggen bzw mit "vqb fullchunk" ersetzen? uploadsystem müsste man auch taggen?
* Spike2: Ich habe jetzt erstmal nur den ConChecker eingebaut; dass der ConChecker für Prüfung auf Update bzw. für UPnP-Neueinstellung (<- überhaupt nötig ?) genutzt wird, fehlt noch

* shadow2004: lphant v3.00 ist raus und auch nen neuer eDonkey 1.4.3b. Ob die bestimmte neue Funktionen unterstützen weiß ich noch nicht.
              emulations dhingehend prüfen ?
==> Spike2: geprüft ist ! Der lphant hat keine weiteren Protokoll-Änderungen erhalten, scheint auch kein Crumb-/Horde-Support (mehr) zu haben. Auch beim eDonkey 1.4.5 nix Neues... emulations können also so bleiben, wie sie jetzt sind !

* IPFilter-Autocompletion : Bei einer Cleaninstall eine URL-Datei mit pawcio und emulefuture-Links erstellen
     EMF_IPFilterUpdateURLs.dat
		http://www.emulefuture.eu/emulefuture/ipfilter.txt
		http://emulepawcio.sourceforge.net/nieuwe_site/Ipfilter_fakes/ipfilter.zip
* JvA: sollte das Dropsystem eingebaut werden sowie die LODATIP dann bitte die auskommentierten zeilen in der "sourcesaver.cpp" beachten
* dlarge: KadAddOns werden denk ich mal nicht mehr gebraucht seit 0.49a?